/*  */
#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int N, K;
    cin>>N>>K;
    
    int niz[N];
    for (int i=0; i<N; i++)
    {
        cin>>niz[i];
    }
    
    int kniz[N];
    for (int i=0; i<N; i++)
    {
        kniz[i]=niz[i];
    }
    
    int n = sizeof(kniz) / sizeof(kniz[0]);
    sort(kniz, kniz + n, greater<int>());
    
    int najveci=kniz[0];
    int k2=K-1;
    int najniz[K];
    for (int i=0; i<k2; i++)
    {
        najniz[K-(i+1)]=kniz[N-(i+1)];
    }
    najniz[0]=najveci;
    
    
    int rezultat;
    for (int i=1;i<K;i++)
    {
        if (najniz[K-1]-najniz[i-1]<najniz[i-1]-najniz[K-1])
        {
            najniz[i-1]=najniz[i-1]-najniz[K-1];
            K=K-1;
            rezultat=najniz[i-1];
        }else{
            najniz[K-1]=najniz[K-1]-najniz[i-1];
            rezultat=najniz[K-1];
        }
    }
    cout<<rezultat;
    
    return 0;
}